import numpy
import pytest

import optimesh

from .meshes import circle_gmsh2, circle_random, circle_random2


@pytest.mark.skip("Not implemented yet.")
def test_circle():
    x0 = numpy.array([0.0, 0.0])
    target_r = 1.0

    def boundary_step(x):
        # simply project onto the circle
        y = x - x0[:, None]
        r = numpy.sqrt(numpy.einsum("ij,ij->j", y, y))
        out = y / r * target_r + x0[:, None]
        return out

    # X, cells = circle_random2(150, target_r)
    X, cells = circle_random(40, target_r)
    # X, cells = circle_gmsh2()

    # X, cells = optimesh.cvt.quasi_newton_uniform_lloyd(
    #     X, cells, 1.0e-6, 100, omega=2.0
    # )

    X, cells = optimesh.bco.fixed_point_uniform(
        X, cells, 1.0e-6, 1000, boundary_step=boundary_step
    )


if __name__ == "__main__":
    test_circle()
